<?php
/*
  $Id: contrib_tracker.php,v 1.7.18 2009/09/06 17:33:32 SteveDallas Exp $
  
  29 Jan 2011 GCH 1.7.18 Changed test for updated module to use contrib_link instead of contrib_title, which is not guaranteed to be unique.
						 Removed dependency on application_top.php
                           Added only the items from application_top.php that are required to run the cron task
						 Suppress output if run from the shell (usually from crontab)

  05 Sep 2009 GCH 1.7.17 Complete rewrite of RDF file handling.
                           No longer requires or creates a cache file
                         Complete rewrite of XML parsing - no longer uses rdf_class.php 
						 Changed email message to include names and links to updated files
						   Only sends email the first time that a file is updated

  24 May 2009 GCH 1.7.15 Fixed detection/creation of local cache file for servers where DIR_FS_CATALOG != DIR_WS_CATALOG
                         Made the HTML output compliant with the HTML 4.01 DTD
                         Cleaned up the email notification option.  


  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
_________________________________________________________________

Contribution Tracker MODULE for osC Admin
By Admin of www.silvermoon-jewelry.com
Based on:
		Admin_notes: Original Code By: Robert Hellemans of www.RuddlesMills.com
		RSS News for OSC
These are LIVE SHOPS - So please, no TEST accounts etc...
We will report you to your ISP if you abuse our websites!
*/

// If true, send the feed to admin if we can't find any articles in the RSS file
$debug_mode = true;

// include server parameters
  require('includes/configure.php');

// include the list of project database tables
  require(DIR_WS_INCLUDES . 'database_tables.php');

// include the database functions
  require(DIR_WS_FUNCTIONS . 'database.php');

// make a connection to the database... now
  tep_db_connect() or die('Unable to connect to database server!');

// set the application parameters
  $configuration_query = tep_db_query('select configuration_key as cfgKey, configuration_value as cfgValue from ' . TABLE_CONFIGURATION);
  while ($configuration = tep_db_fetch_array($configuration_query)) {
    define($configuration['cfgKey'], $configuration['cfgValue']);
  }

// define general functions used application-wide
  require(DIR_WS_FUNCTIONS . 'general.php');

// include the mail classes
  require(DIR_WS_CLASSES . 'mime.php');
  require(DIR_WS_CLASSES . 'email.php');

// include validation functions (right now only email address)
  require(DIR_WS_FUNCTIONS . 'validations.php');

// set the language

// dummy function definitions to keep language file from complaining
  function tep_session_save_path() {
    $s = '';
    return $s;
  }
  
  function tep_href_link($s) {
    $s = '';
    return $s;
  }

  include(DIR_WS_CLASSES . 'language.php');
  $lng = new language();

  if (isset($HTTP_GET_VARS['language']) && tep_not_null($HTTP_GET_VARS['language'])) {
    $lng->set_language($HTTP_GET_VARS['language']);
  } else {
    $lng->get_browser_language();
  }

  $language = $lng->language['directory'];
  $languages_id = $lng->language['id'];

// include the language translations
  require(DIR_WS_LANGUAGES . $language . '.php');

$xmlURL='http://feedproxy.feedburner.com/osCommerce_Contributions';
$format = '%Y-%m-%d %H:%M:%S';

//Function to parse the RSS feed
//Does not rely on PHP XML parser due to issues.
    function parse_xml($text) {
      $reg_exp = '/<(\w+)[^>]*>(.*?)<\/\\1>/s';
      preg_match_all($reg_exp, $text, $match);
      foreach ($match[1] as $key=>$val) {
        if ( preg_match($reg_exp, $match[2][$key]) ) {
            $array[$val][] = parse_xml($match[2][$key]);
        } else {
		    if ( preg_match('/<!\[CDATA\[(.*?)\]\]>/s',$match[2][$key], $string) ) {
			    $array[$val] = $string[1];
			} else {
                $array[$val] = $match[2][$key];
			}
        }
      }
      return $array;
    } 

  if (!function_exists("file_get_contents")) {
  //get contents of file into a string
  //For compatibility with PHP4 < 4.3.0
    function file_get_contents($f) {
      $h = @fopen($f, 'rb'); //rss cached file path
      if ($h) {
        $data = '';
        while (!feof($h)) {
          $d .= fread($h, 8192);
	    }
        fclose($h);
      } else {
        $d = $false;
      }
	  return $d;
	}
  }

// Decode HTML special characters (for PHP<5.1.0)
  if (!function_exists("htmlspecialchars_decode")) {
    function htmlspecialchars_decode($string,$style=ENT_COMPAT)
    {
        $translation = array_flip(get_html_translation_table(HTML_SPECIALCHARS,$style));
        if($style === ENT_QUOTES){ $translation['&#039;'] = '\''; }
        return strtr($string,$translation);
    }
  }


// Grab a file using cURL
  function curl_get_osc_contents($OSCURL) {
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_URL, $OSCURL) ;
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$data = curl_exec($ch);
	curl_close($ch); 
	return $data ;
  }

// Install a configuration key to determine whether to send email reports to store owner.  
// Set it to 'false'. (Can be changed in admin Config->E-Mail.)

if (CONTRIB_TRACKER_NOTIFICATION == 'CONTRIB_TRACKER_NOTIFICATION') {
  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, set_function) values ('Contrib Tracker Notification email', 'CONTRIB_TRACKER_NOTIFICATION', 'false', 'Send Contrib Tracker notifications to store owner', '12', '4815', now(), 'tep_cfg_select_option(array(\'true\', \'false\'),')");   
}

// Determine whether we're running from a shell
if (isset($_ENV["SHELL"])) {
  $silent = true;
} else {
  $silent = false;
}

// Make the output minimal valid HTML
if (!$silent) {
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
    <title><?php echo TITLE; ?></title>
  </head>
  <body>
<?php
}

$data = @file_get_contents($xmlURL);

if (!$data && (extension_loaded('curl') == 1)) {
  $data = curl_get_osc_contents($xmlURL);
}

//Initialize counters
$articlecount = 0;
$updated = 0;
$updatedlist = '';

if ($data) {
  $response = parse_xml($data);

  $articlelist = $response['rss'][0]['channel'][0];
  if (is_array($articlelist['item'])) {
    foreach ($articlelist['item'] as $article ) {
      $articlecount++;
      $osc_rss_pubdate = strtotime($article['pubDate']);
      $osc_rss_pubdate = strftime ($format, $osc_rss_pubdate);

// UPDATE THE CONTRIBUTIONS THAT ARE IN THE RSS FILE
      tep_db_query("UPDATE " . TABLE_CONTRIB_TRACKER . " SET status ='0', contr_last_modified = '" . $osc_rss_pubdate . "' where contrib_link = '" . $article['link'] . "' and last_update < '" . $osc_rss_pubdate . "'");
      if (mysql_affected_rows()) {
	    $updated++;
        if (!$silent) { echo $article['title'] . "<br>\n"; }
	    $updatedlist .= $article['title'] . '  ' . $article['link'] . "\n";
        $updatedlist .= htmlspecialchars_decode($article['description']) . "\n\n";
	  }
    }
  } else {
    // There was a problem with the feed.  Send it to the store owner.
    if (tep_validate_email(STORE_OWNER_EMAIL_ADDRESS) && $debug_mode) {
	  $report = print_r($articlelist, true);
      tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, "Contrib Tracker Error", $report, "Contrib Tracker", STORE_OWNER_EMAIL_ADDRESS);
    }   
  }
}

//send an email if any contribs need updating.
if ($updated > 0 && CONTRIB_TRACKER_NOTIFICATION == 'true') {
  $error = false;
  $name = "Contrib Tracker";
  $subject = "Contrib Tracker Summary";
  $enquiry = $articlecount . " contributions have been checked and the following " . $updated . " need updating.\n\n" . $updatedlist;
  if (tep_validate_email(STORE_OWNER_EMAIL_ADDRESS)) {
    tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, $subject, $enquiry, $name, STORE_OWNER_EMAIL_ADDRESS);
  }
}

if (!$silent) { 
echo "success\n"; 
?>
  </body>
</html>
<?php
}
?>
